

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.ZambrettiCore &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.ZambrettiCore</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="k">def</span> <span class="nf">_</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span> <span class="p">:</span> <span class="k">return</span> <span class="n">msg</span>

<span class="n">forecast_text</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s">&#39;A&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Settled fine&quot;</span><span class="p">),</span>
    <span class="s">&#39;B&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fine weather&quot;</span><span class="p">),</span>
    <span class="s">&#39;C&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Becoming fine&quot;</span><span class="p">),</span>
    <span class="s">&#39;D&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fine, becoming less settled&quot;</span><span class="p">),</span>
    <span class="s">&#39;E&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fine, possible showers&quot;</span><span class="p">),</span>
    <span class="s">&#39;F&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fairly fine, improving&quot;</span><span class="p">),</span>
    <span class="s">&#39;G&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fairly fine, possible showers early&quot;</span><span class="p">),</span>
    <span class="s">&#39;H&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fairly fine, showery later&quot;</span><span class="p">),</span>
    <span class="s">&#39;I&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Showery early, improving&quot;</span><span class="p">),</span>
    <span class="s">&#39;J&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Changeable, mending&quot;</span><span class="p">),</span>
    <span class="s">&#39;K&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Fairly fine, showers likely&quot;</span><span class="p">),</span>
    <span class="s">&#39;L&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Rather unsettled clearing later&quot;</span><span class="p">),</span>
    <span class="s">&#39;M&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Unsettled, probably improving&quot;</span><span class="p">),</span>
    <span class="s">&#39;N&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Showery, bright intervals&quot;</span><span class="p">),</span>
    <span class="s">&#39;O&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Showery, becoming less settled&quot;</span><span class="p">),</span>
    <span class="s">&#39;P&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Changeable, some rain&quot;</span><span class="p">),</span>
    <span class="s">&#39;Q&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Unsettled, short fine intervals&quot;</span><span class="p">),</span>
    <span class="s">&#39;R&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Unsettled, rain later&quot;</span><span class="p">),</span>
    <span class="s">&#39;S&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Unsettled, some rain&quot;</span><span class="p">),</span>
    <span class="s">&#39;T&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Mostly very unsettled&quot;</span><span class="p">),</span>
    <span class="s">&#39;U&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Occasional rain, worsening&quot;</span><span class="p">),</span>
    <span class="s">&#39;V&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Rain at times, very unsettled&quot;</span><span class="p">),</span>
    <span class="s">&#39;W&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Rain at frequent intervals&quot;</span><span class="p">),</span>
    <span class="s">&#39;X&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Rain, very unsettled&quot;</span><span class="p">),</span>
    <span class="s">&#39;Y&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Stormy, may improve&quot;</span><span class="p">),</span>
    <span class="s">&#39;Z&#39;</span> <span class="p">:</span> <span class="n">_</span><span class="p">(</span><span class="s">&quot;Stormy, much rain&quot;</span><span class="p">)</span>
    <span class="p">}</span>

<span class="k">del</span> <span class="n">_</span>

<div class="viewcode-block" id="ZambrettiCode"><a class="viewcode-back" href="../../api/pywws.ZambrettiCore.html#pywws.ZambrettiCore.ZambrettiCode">[docs]</a><span class="k">def</span> <span class="nf">ZambrettiCode</span><span class="p">(</span><span class="n">pressure</span><span class="p">,</span> <span class="n">month</span><span class="p">,</span> <span class="n">wind</span><span class="p">,</span> <span class="n">trend</span><span class="p">,</span>
                  <span class="n">north</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">baro_top</span><span class="o">=</span><span class="mf">1050.0</span><span class="p">,</span> <span class="n">baro_bottom</span><span class="o">=</span><span class="mf">950.0</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Simple implementation of Zambretti forecaster algorithm.</span>
<span class="sd">    Inspired by beteljuice.com Java algorithm, as converted to Python by</span>
<span class="sd">    honeysucklecottage.me.uk, and further information</span>
<span class="sd">    from http://www.meteormetrics.com/zambretti.htm&quot;&quot;&quot;</span>
    <span class="c"># normalise pressure</span>
    <span class="n">pressure</span> <span class="o">=</span> <span class="mf">950.0</span> <span class="o">+</span> <span class="p">((</span><span class="mf">1050.0</span> <span class="o">-</span> <span class="mf">950.0</span><span class="p">)</span> <span class="o">*</span>
                        <span class="p">(</span><span class="n">pressure</span> <span class="o">-</span> <span class="n">baro_bottom</span><span class="p">)</span> <span class="o">/</span> <span class="p">(</span><span class="n">baro_top</span> <span class="o">-</span> <span class="n">baro_bottom</span><span class="p">))</span>
    <span class="c"># adjust pressure for wind direction</span>
    <span class="k">if</span> <span class="n">wind</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">:</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">north</span><span class="p">:</span>
            <span class="c"># southern hemisphere, so add 180 degrees</span>
            <span class="n">wind</span> <span class="o">=</span> <span class="p">(</span><span class="n">wind</span> <span class="o">+</span> <span class="mi">8</span><span class="p">)</span> <span class="o">%</span> <span class="mi">16</span>
        <span class="n">pressure</span> <span class="o">+=</span> <span class="p">(</span>  <span class="mf">5.2</span><span class="p">,</span>  <span class="mf">4.2</span><span class="p">,</span>  <span class="mf">3.2</span><span class="p">,</span>  <span class="mf">1.05</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">3.15</span><span class="p">,</span> <span class="o">-</span><span class="mf">5.2</span><span class="p">,</span> <span class="o">-</span><span class="mf">8.35</span><span class="p">,</span>
                     <span class="o">-</span><span class="mf">11.5</span><span class="p">,</span> <span class="o">-</span><span class="mf">9.4</span><span class="p">,</span> <span class="o">-</span><span class="mf">7.3</span><span class="p">,</span> <span class="o">-</span><span class="mf">5.25</span><span class="p">,</span> <span class="o">-</span><span class="mf">3.2</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.15</span><span class="p">,</span>  <span class="mf">0.9</span><span class="p">,</span>  <span class="mf">3.05</span><span class="p">)[</span><span class="n">wind</span><span class="p">]</span>
    <span class="c"># compute base forecast from pressure and trend (hPa / hour)</span>
    <span class="k">if</span> <span class="n">trend</span> <span class="o">&gt;=</span> <span class="mf">0.1</span><span class="p">:</span>
        <span class="c"># rising pressure</span>
        <span class="k">if</span> <span class="n">north</span> <span class="o">==</span> <span class="p">(</span><span class="n">month</span> <span class="o">&gt;=</span> <span class="mi">4</span> <span class="ow">and</span> <span class="n">month</span> <span class="o">&lt;=</span> <span class="mi">9</span><span class="p">):</span>
            <span class="n">pressure</span> <span class="o">+=</span> <span class="mf">3.2</span>
        <span class="n">F</span> <span class="o">=</span> <span class="mf">0.1740</span> <span class="o">*</span> <span class="p">(</span><span class="mf">1031.40</span> <span class="o">-</span> <span class="n">pressure</span><span class="p">)</span>
        <span class="n">LUT</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;A&#39;</span><span class="p">,</span> <span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;C&#39;</span><span class="p">,</span> <span class="s">&#39;F&#39;</span><span class="p">,</span> <span class="s">&#39;G&#39;</span><span class="p">,</span> <span class="s">&#39;I&#39;</span><span class="p">,</span> <span class="s">&#39;J&#39;</span><span class="p">,</span> <span class="s">&#39;L&#39;</span><span class="p">,</span> <span class="s">&#39;M&#39;</span><span class="p">,</span> <span class="s">&#39;M&#39;</span><span class="p">,</span> <span class="s">&#39;Q&#39;</span><span class="p">,</span> <span class="s">&#39;T&#39;</span><span class="p">,</span>
               <span class="s">&#39;Y&#39;</span><span class="p">)</span>
    <span class="k">elif</span> <span class="n">trend</span> <span class="o">&lt;=</span> <span class="o">-</span><span class="mf">0.1</span><span class="p">:</span>
        <span class="c"># falling pressure</span>
        <span class="k">if</span> <span class="n">north</span> <span class="o">==</span> <span class="p">(</span><span class="n">month</span> <span class="o">&gt;=</span> <span class="mi">4</span> <span class="ow">and</span> <span class="n">month</span> <span class="o">&lt;=</span> <span class="mi">9</span><span class="p">):</span>
            <span class="n">pressure</span> <span class="o">-=</span> <span class="mf">3.2</span>
        <span class="n">F</span> <span class="o">=</span> <span class="mf">0.1553</span> <span class="o">*</span> <span class="p">(</span><span class="mf">1029.95</span> <span class="o">-</span> <span class="n">pressure</span><span class="p">)</span>
        <span class="n">LUT</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;D&#39;</span><span class="p">,</span> <span class="s">&#39;H&#39;</span><span class="p">,</span> <span class="s">&#39;O&#39;</span><span class="p">,</span> <span class="s">&#39;R&#39;</span><span class="p">,</span> <span class="s">&#39;U&#39;</span><span class="p">,</span> <span class="s">&#39;V&#39;</span><span class="p">,</span> <span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;Z&#39;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="c"># steady</span>
        <span class="n">F</span> <span class="o">=</span> <span class="mf">0.2314</span> <span class="o">*</span> <span class="p">(</span><span class="mf">1030.81</span> <span class="o">-</span> <span class="n">pressure</span><span class="p">)</span>
        <span class="n">LUT</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;A&#39;</span><span class="p">,</span> <span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;E&#39;</span><span class="p">,</span> <span class="s">&#39;K&#39;</span><span class="p">,</span> <span class="s">&#39;N&#39;</span><span class="p">,</span> <span class="s">&#39;N&#39;</span><span class="p">,</span> <span class="s">&#39;P&#39;</span><span class="p">,</span> <span class="s">&#39;P&#39;</span><span class="p">,</span> <span class="s">&#39;S&#39;</span><span class="p">,</span> <span class="s">&#39;W&#39;</span><span class="p">,</span> <span class="s">&#39;W&#39;</span><span class="p">,</span>
               <span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;Z&#39;</span><span class="p">)</span>
    <span class="c"># clip to range of lookup table</span>
    <span class="n">F</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="nb">max</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">F</span> <span class="o">+</span> <span class="mf">0.5</span><span class="p">),</span> <span class="mi">0</span><span class="p">),</span> <span class="nb">len</span><span class="p">(</span><span class="n">LUT</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>
    <span class="c"># convert to letter code</span>
    <span class="k">return</span> <span class="n">LUT</span><span class="p">[</span><span class="n">F</span><span class="p">]</span>
</div>
<div class="viewcode-block" id="ZambrettiText"><a class="viewcode-back" href="../../api/pywws.ZambrettiCore.html#pywws.ZambrettiCore.ZambrettiText">[docs]</a><span class="k">def</span> <span class="nf">ZambrettiText</span><span class="p">(</span><span class="n">letter</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">forecast_text</span><span class="p">[</span><span class="n">letter</span><span class="p">]</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="kn">import</span> <span class="nn">WeatherStation</span>
    <span class="n">wind_dir</span> <span class="o">=</span> <span class="n">WeatherStation</span><span class="o">.</span><span class="n">get_wind_dir_text</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">pressure</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1030</span><span class="p">,</span> <span class="mi">960</span><span class="p">,</span> <span class="o">-</span><span class="mi">10</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">trend_txt</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;S&#39;</span><span class="p">,</span> <span class="s">&#39;R-S&#39;</span><span class="p">,</span> <span class="s">&#39;R-W&#39;</span><span class="p">,</span> <span class="s">&#39;F-W&#39;</span><span class="p">,</span> <span class="s">&#39;F-S&#39;</span><span class="p">):</span>
            <span class="n">trend</span><span class="p">,</span> <span class="n">month</span> <span class="o">=</span> <span class="p">{</span>
                <span class="s">&#39;R-W&#39;</span> <span class="p">:</span> <span class="p">(</span> <span class="mf">0.2</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span>
                <span class="s">&#39;F-W&#39;</span> <span class="p">:</span> <span class="p">(</span><span class="o">-</span><span class="mf">0.2</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span>
                <span class="s">&#39;R-S&#39;</span> <span class="p">:</span> <span class="p">(</span> <span class="mf">0.2</span><span class="p">,</span> <span class="mi">7</span><span class="p">),</span>
                <span class="s">&#39;F-S&#39;</span> <span class="p">:</span> <span class="p">(</span><span class="o">-</span><span class="mf">0.2</span><span class="p">,</span> <span class="mi">7</span><span class="p">),</span>
                <span class="s">&#39;S&#39;</span>   <span class="p">:</span> <span class="p">(</span> <span class="mf">0.0</span><span class="p">,</span> <span class="mi">7</span><span class="p">),</span>
                <span class="p">}[</span><span class="n">trend_txt</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">wind</span> <span class="ow">in</span> <span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="bp">None</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">12</span><span class="p">,</span> <span class="mi">6</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">8</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">wind</span> <span class="o">==</span> <span class="bp">None</span><span class="p">:</span>
                    <span class="n">wind_txt</span> <span class="o">=</span> <span class="s">&#39;calm&#39;</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">wind_txt</span> <span class="o">=</span> <span class="n">wind_dir</span><span class="p">[</span><span class="n">wind</span><span class="p">]</span>
                <span class="k">print</span> <span class="s">&#39;</span><span class="si">%4d</span><span class="s"> </span><span class="si">%4s</span><span class="s"> </span><span class="si">%4s</span><span class="s">  </span><span class="si">%3s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
                    <span class="n">pressure</span><span class="p">,</span> <span class="n">trend_txt</span><span class="p">,</span> <span class="n">wind_txt</span><span class="p">,</span>
                    <span class="n">ZambrettiCode</span><span class="p">(</span><span class="n">pressure</span><span class="p">,</span> <span class="n">month</span><span class="p">,</span> <span class="n">wind</span><span class="p">,</span> <span class="n">trend</span><span class="p">))</span>
        <span class="k">print</span> <span class="s">&#39;&#39;</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>